# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

.allocate_arrow_array_as_xptr <- function() {
    .Call(`_tiledb_allocate_arrow_array_as_xptr`)
}

.allocate_arrow_schema_as_xptr <- function() {
    .Call(`_tiledb_allocate_arrow_schema_as_xptr`)
}

.delete_arrow_array_from_xptr <- function(sxp) {
    invisible(.Call(`_tiledb_delete_arrow_array_from_xptr`, sxp))
}

.delete_arrow_schema_from_xptr <- function(sxp) {
    invisible(.Call(`_tiledb_delete_arrow_schema_from_xptr`, sxp))
}

libtiledb_query_export_buffer <- function(ctx, query, name) {
    .Call(`_tiledb_libtiledb_query_export_buffer`, ctx, query, name)
}

libtiledb_query_import_buffer <- function(ctx, query, name, arrowpointers) {
    .Call(`_tiledb_libtiledb_query_import_buffer`, ctx, query, name, arrowpointers)
}

makeQueryWrapper <- function(qp) {
    .Call(`_tiledb_makeQueryWrapper`, qp)
}

libtiledb_query_add_range_with_type <- function(query, iidx, typestr, starts, ends, strides = NULL) {
    .Call(`_tiledb_libtiledb_query_add_range_with_type`, query, iidx, typestr, starts, ends, strides)
}

libtiledb_query_add_range <- function(query, iidx, starts, ends, strides = NULL) {
    .Call(`_tiledb_libtiledb_query_add_range`, query, iidx, starts, ends, strides)
}

tiledb_datatype_string_to_sizeof <- function(str) {
    .Call(`_tiledb_tiledb_datatype_string_to_sizeof`, str)
}

#' Map from TileDB type to R datatype
#'
#' This function maps from the TileDB types to the (fewer) key datatypes in R. This
#' can be lossy as TileDB integers range from (signed and unsigned) 8 to 64 bit whereas
#' R only has (signed) 32 bit values. Similarly, R only has 64 bit doubles whereas TileDB
#' has 32 and 64 bit floating point types. TileDB also has more character encodings, and the
#' full range of (NumPy) date and time types.
#'
#' @param datatype A string describing one TileDB datatype
#' @return A string describing the closest match for an R datatype
#' @export
tiledb_datatype_R_type <- function(datatype) {
    .Call(`_tiledb_tiledb_datatype_R_type`, datatype)
}

libtiledb_version <- function() {
    .Call(`_tiledb_libtiledb_version`)
}

libtiledb_ctx <- function(config = NULL) {
    .Call(`_tiledb_libtiledb_ctx`, config)
}

libtiledb_ctx_config <- function(ctx) {
    .Call(`_tiledb_libtiledb_ctx_config`, ctx)
}

libtiledb_ctx_is_supported_fs <- function(ctx, scheme) {
    .Call(`_tiledb_libtiledb_ctx_is_supported_fs`, ctx, scheme)
}

libtiledb_ctx_set_tag <- function(ctx, key, value) {
    invisible(.Call(`_tiledb_libtiledb_ctx_set_tag`, ctx, key, value))
}

libtiledb_ctx_stats <- function(ctx) {
    .Call(`_tiledb_libtiledb_ctx_stats`, ctx)
}

libtiledb_config <- function(config = NULL) {
    .Call(`_tiledb_libtiledb_config`, config)
}

libtiledb_config_save_to_file <- function(config, filename) {
    .Call(`_tiledb_libtiledb_config_save_to_file`, config, filename)
}

libtiledb_config_load_from_file <- function(filename) {
    .Call(`_tiledb_libtiledb_config_load_from_file`, filename)
}

libtiledb_config_vector <- function(config) {
    .Call(`_tiledb_libtiledb_config_vector`, config)
}

libtiledb_config_set <- function(config, param, value) {
    .Call(`_tiledb_libtiledb_config_set`, config, param, value)
}

libtiledb_config_get <- function(config, params) {
    .Call(`_tiledb_libtiledb_config_get`, config, params)
}

libtiledb_config_unset <- function(config, param) {
    .Call(`_tiledb_libtiledb_config_unset`, config, param)
}

libtiledb_config_dump <- function(config) {
    invisible(.Call(`_tiledb_libtiledb_config_dump`, config))
}

libtiledb_dim <- function(ctx, name, type, domain, tile_extent) {
    .Call(`_tiledb_libtiledb_dim`, ctx, name, type, domain, tile_extent)
}

libtiledb_dim_get_name <- function(dim) {
    .Call(`_tiledb_libtiledb_dim_get_name`, dim)
}

libtiledb_dim_get_domain <- function(dim) {
    .Call(`_tiledb_libtiledb_dim_get_domain`, dim)
}

libtiledb_dim_get_tile_extent <- function(dim) {
    .Call(`_tiledb_libtiledb_dim_get_tile_extent`, dim)
}

libtiledb_dim_get_datatype <- function(dim) {
    .Call(`_tiledb_libtiledb_dim_get_datatype`, dim)
}

dim_domain_subarray <- function(domain, subscript) {
    .Call(`_tiledb_dim_domain_subarray`, domain, subscript)
}

libtiledb_dim_get_cell_val_num <- function(dim) {
    .Call(`_tiledb_libtiledb_dim_get_cell_val_num`, dim)
}

libtiledb_dimension_get_filter_list <- function(dim) {
    .Call(`_tiledb_libtiledb_dimension_get_filter_list`, dim)
}

libtiledb_dimension_set_filter_list <- function(dim, fltrlst) {
    .Call(`_tiledb_libtiledb_dimension_set_filter_list`, dim, fltrlst)
}

libtiledb_domain <- function(ctx, dims) {
    .Call(`_tiledb_libtiledb_domain`, ctx, dims)
}

libtiledb_domain_get_type <- function(domain) {
    .Call(`_tiledb_libtiledb_domain_get_type`, domain)
}

libtiledb_domain_get_ndim <- function(domain) {
    .Call(`_tiledb_libtiledb_domain_get_ndim`, domain)
}

libtiledb_domain_get_dimension_from_index <- function(dom, idx) {
    .Call(`_tiledb_libtiledb_domain_get_dimension_from_index`, dom, idx)
}

libtiledb_domain_get_dimension_from_name <- function(dom, name) {
    .Call(`_tiledb_libtiledb_domain_get_dimension_from_name`, dom, name)
}

libtiledb_domain_get_dimensions <- function(domain) {
    .Call(`_tiledb_libtiledb_domain_get_dimensions`, domain)
}

libtiledb_domain_has_dimension <- function(domain, name) {
    .Call(`_tiledb_libtiledb_domain_has_dimension`, domain, name)
}

libtiledb_domain_dump <- function(domain) {
    invisible(.Call(`_tiledb_libtiledb_domain_dump`, domain))
}

libtiledb_filter <- function(ctx, filter) {
    .Call(`_tiledb_libtiledb_filter`, ctx, filter)
}

libtiledb_filter_get_type <- function(filter) {
    .Call(`_tiledb_libtiledb_filter_get_type`, filter)
}

libtiledb_filter_get_option <- function(filter, filter_option_str) {
    .Call(`_tiledb_libtiledb_filter_get_option`, filter, filter_option_str)
}

libtiledb_filter_set_option <- function(filter, filter_option_str, valuesxp) {
    .Call(`_tiledb_libtiledb_filter_set_option`, filter, filter_option_str, valuesxp)
}

libtiledb_filter_list <- function(ctx, filters) {
    .Call(`_tiledb_libtiledb_filter_list`, ctx, filters)
}

libtiledb_filter_list_set_max_chunk_size <- function(filterList, max_chunk_size) {
    invisible(.Call(`_tiledb_libtiledb_filter_list_set_max_chunk_size`, filterList, max_chunk_size))
}

libtiledb_filter_list_get_max_chunk_size <- function(filterList) {
    .Call(`_tiledb_libtiledb_filter_list_get_max_chunk_size`, filterList)
}

libtiledb_filter_list_get_nfilters <- function(filterList) {
    .Call(`_tiledb_libtiledb_filter_list_get_nfilters`, filterList)
}

libtiledb_filter_list_get_filter_from_index <- function(filterList, filter_index) {
    .Call(`_tiledb_libtiledb_filter_list_get_filter_from_index`, filterList, filter_index)
}

libtiledb_attribute <- function(ctx, name, type, fltrlst, ncells, nullable) {
    .Call(`_tiledb_libtiledb_attribute`, ctx, name, type, fltrlst, ncells, nullable)
}

libtiledb_attribute_get_name <- function(attr) {
    .Call(`_tiledb_libtiledb_attribute_get_name`, attr)
}

libtiledb_attribute_get_type <- function(attr) {
    .Call(`_tiledb_libtiledb_attribute_get_type`, attr)
}

libtiledb_attribute_get_cell_size <- function(attr) {
    .Call(`_tiledb_libtiledb_attribute_get_cell_size`, attr)
}

libtiledb_attribute_get_filter_list <- function(attr) {
    .Call(`_tiledb_libtiledb_attribute_get_filter_list`, attr)
}

libtiledb_attribute_set_filter_list <- function(attr, fltrlst) {
    .Call(`_tiledb_libtiledb_attribute_set_filter_list`, attr, fltrlst)
}

libtiledb_attribute_get_cell_val_num <- function(attr) {
    .Call(`_tiledb_libtiledb_attribute_get_cell_val_num`, attr)
}

libtiledb_attribute_set_cell_val_num <- function(attr, num) {
    invisible(.Call(`_tiledb_libtiledb_attribute_set_cell_val_num`, attr, num))
}

libtiledb_attribute_is_variable_sized <- function(attr) {
    .Call(`_tiledb_libtiledb_attribute_is_variable_sized`, attr)
}

libtiledb_attribute_dump <- function(attr) {
    invisible(.Call(`_tiledb_libtiledb_attribute_dump`, attr))
}

libtiledb_attribute_set_fill_value <- function(attr, val) {
    invisible(.Call(`_tiledb_libtiledb_attribute_set_fill_value`, attr, val))
}

libtiledb_attribute_get_fill_value <- function(attr) {
    .Call(`_tiledb_libtiledb_attribute_get_fill_value`, attr)
}

libtiledb_attribute_set_nullable <- function(attr, flag) {
    invisible(.Call(`_tiledb_libtiledb_attribute_set_nullable`, attr, flag))
}

libtiledb_attribute_get_nullable <- function(attr) {
    .Call(`_tiledb_libtiledb_attribute_get_nullable`, attr)
}

libtiledb_array_schema <- function(ctx, domain, attributes, cell_order, tile_order, coords_filter_list = NULL, offsets_filter_list = NULL, validity_filter_list = NULL, sparse = FALSE) {
    .Call(`_tiledb_libtiledb_array_schema`, ctx, domain, attributes, cell_order, tile_order, coords_filter_list, offsets_filter_list, validity_filter_list, sparse)
}

libtiledb_array_schema_create <- function(ctx, atstr) {
    .Call(`_tiledb_libtiledb_array_schema_create`, ctx, atstr)
}

libtiledb_array_schema_load <- function(ctx, uri) {
    .Call(`_tiledb_libtiledb_array_schema_load`, ctx, uri)
}

libtiledb_array_schema_load_with_key <- function(ctx, uri, key) {
    .Call(`_tiledb_libtiledb_array_schema_load_with_key`, ctx, uri, key)
}

libtiledb_array_schema_set_domain <- function(schema, dom) {
    invisible(.Call(`_tiledb_libtiledb_array_schema_set_domain`, schema, dom))
}

libtiledb_array_schema_get_domain <- function(schema) {
    .Call(`_tiledb_libtiledb_array_schema_get_domain`, schema)
}

libtiledb_array_schema_add_attribute <- function(schema, attr) {
    invisible(.Call(`_tiledb_libtiledb_array_schema_add_attribute`, schema, attr))
}

libtiledb_array_schema_attributes <- function(schema) {
    .Call(`_tiledb_libtiledb_array_schema_attributes`, schema)
}

libtiledb_array_schema_get_array_type <- function(schema) {
    .Call(`_tiledb_libtiledb_array_schema_get_array_type`, schema)
}

libtiledb_array_schema_set_cell_order <- function(schema, ord) {
    invisible(.Call(`_tiledb_libtiledb_array_schema_set_cell_order`, schema, ord))
}

libtiledb_array_schema_get_cell_order <- function(schema) {
    .Call(`_tiledb_libtiledb_array_schema_get_cell_order`, schema)
}

libtiledb_array_schema_set_tile_order <- function(schema, ord) {
    invisible(.Call(`_tiledb_libtiledb_array_schema_set_tile_order`, schema, ord))
}

libtiledb_array_schema_get_tile_order <- function(schema) {
    .Call(`_tiledb_libtiledb_array_schema_get_tile_order`, schema)
}

libtiledb_array_schema_set_capacity <- function(schema, cap) {
    invisible(.Call(`_tiledb_libtiledb_array_schema_set_capacity`, schema, cap))
}

libtiledb_array_schema_get_capacity <- function(schema) {
    .Call(`_tiledb_libtiledb_array_schema_get_capacity`, schema)
}

libtiledb_array_schema_get_allows_dups <- function(schema) {
    .Call(`_tiledb_libtiledb_array_schema_get_allows_dups`, schema)
}

libtiledb_array_schema_set_allows_dups <- function(schema, allows_dups) {
    .Call(`_tiledb_libtiledb_array_schema_set_allows_dups`, schema, allows_dups)
}

libtiledb_array_schema_get_coords_filter_list <- function(schema) {
    .Call(`_tiledb_libtiledb_array_schema_get_coords_filter_list`, schema)
}

libtiledb_array_schema_set_coords_filter_list <- function(schema, fltrlst) {
    .Call(`_tiledb_libtiledb_array_schema_set_coords_filter_list`, schema, fltrlst)
}

libtiledb_array_schema_get_offsets_filter_list <- function(schema) {
    .Call(`_tiledb_libtiledb_array_schema_get_offsets_filter_list`, schema)
}

libtiledb_array_schema_set_offsets_filter_list <- function(schema, fltrlst) {
    .Call(`_tiledb_libtiledb_array_schema_set_offsets_filter_list`, schema, fltrlst)
}

libtiledb_array_schema_get_validity_filter_list <- function(schema) {
    .Call(`_tiledb_libtiledb_array_schema_get_validity_filter_list`, schema)
}

libtiledb_array_schema_set_validity_filter_list <- function(schema, fltrlst) {
    .Call(`_tiledb_libtiledb_array_schema_set_validity_filter_list`, schema, fltrlst)
}

libtiledb_array_schema_get_attribute_num <- function(schema) {
    .Call(`_tiledb_libtiledb_array_schema_get_attribute_num`, schema)
}

libtiledb_array_schema_get_attribute_from_index <- function(schema, ind) {
    .Call(`_tiledb_libtiledb_array_schema_get_attribute_from_index`, schema, ind)
}

libtiledb_array_schema_get_attribute_from_name <- function(schema, name) {
    .Call(`_tiledb_libtiledb_array_schema_get_attribute_from_name`, schema, name)
}

libtiledb_array_schema_has_attribute <- function(schema, name) {
    .Call(`_tiledb_libtiledb_array_schema_has_attribute`, schema, name)
}

libtiledb_array_schema_sparse <- function(schema) {
    .Call(`_tiledb_libtiledb_array_schema_sparse`, schema)
}

libtiledb_array_schema_dump <- function(schema) {
    invisible(.Call(`_tiledb_libtiledb_array_schema_dump`, schema))
}

libtiledb_array_schema_check <- function(schema) {
    .Call(`_tiledb_libtiledb_array_schema_check`, schema)
}

libtiledb_array_schema_evolution <- function(ctx) {
    .Call(`_tiledb_libtiledb_array_schema_evolution`, ctx)
}

libtiledb_array_schema_evolution_add_attribute <- function(ase, attr) {
    .Call(`_tiledb_libtiledb_array_schema_evolution_add_attribute`, ase, attr)
}

libtiledb_array_schema_evolution_drop_attribute <- function(ase, attrname) {
    .Call(`_tiledb_libtiledb_array_schema_evolution_drop_attribute`, ase, attrname)
}

libtiledb_array_schema_evolution_array_evolve <- function(ase, uri) {
    .Call(`_tiledb_libtiledb_array_schema_evolution_array_evolve`, ase, uri)
}

libtiledb_array_create <- function(uri, schema) {
    .Call(`_tiledb_libtiledb_array_create`, uri, schema)
}

libtiledb_array_create_with_key <- function(uri, schema, encryption_key) {
    .Call(`_tiledb_libtiledb_array_create_with_key`, uri, schema, encryption_key)
}

libtiledb_array_open <- function(ctx, uri, type) {
    .Call(`_tiledb_libtiledb_array_open`, ctx, uri, type)
}

libtiledb_array_open_at <- function(ctx, uri, type, tstamp) {
    .Call(`_tiledb_libtiledb_array_open_at`, ctx, uri, type, tstamp)
}

libtiledb_array_open_with_key <- function(ctx, uri, type, enc_key) {
    .Call(`_tiledb_libtiledb_array_open_with_key`, ctx, uri, type, enc_key)
}

libtiledb_array_open_at_with_key <- function(ctx, uri, type, enc_key, tstamp) {
    .Call(`_tiledb_libtiledb_array_open_at_with_key`, ctx, uri, type, enc_key, tstamp)
}

libtiledb_array_open_with_ptr <- function(array, query_type) {
    .Call(`_tiledb_libtiledb_array_open_with_ptr`, array, query_type)
}

libtiledb_array_is_open <- function(array) {
    .Call(`_tiledb_libtiledb_array_is_open`, array)
}

libtiledb_array_is_open_for_reading <- function(array) {
    .Call(`_tiledb_libtiledb_array_is_open_for_reading`, array)
}

libtiledb_array_is_open_for_writing <- function(array) {
    .Call(`_tiledb_libtiledb_array_is_open_for_writing`, array)
}

libtiledb_array_get_uri <- function(array) {
    .Call(`_tiledb_libtiledb_array_get_uri`, array)
}

libtiledb_array_get_schema <- function(array) {
    .Call(`_tiledb_libtiledb_array_get_schema`, array)
}

libtiledb_array_reopen <- function(array) {
    .Call(`_tiledb_libtiledb_array_reopen`, array)
}

libtiledb_array_close <- function(array) {
    .Call(`_tiledb_libtiledb_array_close`, array)
}

libtiledb_array_query_type <- function(array) {
    .Call(`_tiledb_libtiledb_array_query_type`, array)
}

libtiledb_array_get_non_empty_domain <- function(array) {
    .Call(`_tiledb_libtiledb_array_get_non_empty_domain`, array)
}

libtiledb_array_get_non_empty_domain_var_from_name <- function(array, name) {
    .Call(`_tiledb_libtiledb_array_get_non_empty_domain_var_from_name`, array, name)
}

libtiledb_array_get_non_empty_domain_var_from_index <- function(array, idx, typestr = "ASCII") {
    .Call(`_tiledb_libtiledb_array_get_non_empty_domain_var_from_index`, array, idx, typestr)
}

libtiledb_array_get_non_empty_domain_from_name <- function(array, name, typestr) {
    .Call(`_tiledb_libtiledb_array_get_non_empty_domain_from_name`, array, name, typestr)
}

libtiledb_array_get_non_empty_domain_from_index <- function(array, idx, typestr) {
    .Call(`_tiledb_libtiledb_array_get_non_empty_domain_from_index`, array, idx, typestr)
}

libtiledb_array_consolidate <- function(ctx, uri, cfgptr = NULL) {
    invisible(.Call(`_tiledb_libtiledb_array_consolidate`, ctx, uri, cfgptr))
}

libtiledb_array_vacuum <- function(ctx, uri, cfgptr = NULL) {
    invisible(.Call(`_tiledb_libtiledb_array_vacuum`, ctx, uri, cfgptr))
}

libtiledb_array_put_metadata <- function(array, key, obj) {
    .Call(`_tiledb_libtiledb_array_put_metadata`, array, key, obj)
}

libtiledb_array_get_metadata_num <- function(array) {
    .Call(`_tiledb_libtiledb_array_get_metadata_num`, array)
}

libtiledb_array_get_metadata_from_index <- function(array, idx) {
    .Call(`_tiledb_libtiledb_array_get_metadata_from_index`, array, idx)
}

libtiledb_array_get_metadata_list <- function(array) {
    .Call(`_tiledb_libtiledb_array_get_metadata_list`, array)
}

libtiledb_array_delete_metadata <- function(array, key) {
    invisible(.Call(`_tiledb_libtiledb_array_delete_metadata`, array, key))
}

libtiledb_array_set_open_timestamp_start <- function(array, tstamp) {
    .Call(`_tiledb_libtiledb_array_set_open_timestamp_start`, array, tstamp)
}

libtiledb_array_open_timestamp_start <- function(array) {
    .Call(`_tiledb_libtiledb_array_open_timestamp_start`, array)
}

libtiledb_array_set_open_timestamp_end <- function(array, tstamp) {
    .Call(`_tiledb_libtiledb_array_set_open_timestamp_end`, array, tstamp)
}

libtiledb_array_open_timestamp_end <- function(array) {
    .Call(`_tiledb_libtiledb_array_open_timestamp_end`, array)
}

libtiledb_array_delete_fragments <- function(array, tstamp_start, tstamp_end) {
    invisible(.Call(`_tiledb_libtiledb_array_delete_fragments`, array, tstamp_start, tstamp_end))
}

libtiledb_query <- function(ctx, array, type) {
    .Call(`_tiledb_libtiledb_query`, ctx, array, type)
}

libtiledb_query_type <- function(query) {
    .Call(`_tiledb_libtiledb_query_type`, query)
}

libtiledb_query_set_layout <- function(query, layout) {
    .Call(`_tiledb_libtiledb_query_set_layout`, query, layout)
}

libtiledb_query_layout <- function(query) {
    .Call(`_tiledb_libtiledb_query_layout`, query)
}

libtiledb_query_set_subarray_with_type <- function(query, subarray, typestr) {
    .Call(`_tiledb_libtiledb_query_set_subarray_with_type`, query, subarray, typestr)
}

libtiledb_query_set_subarray <- function(query, subarray) {
    .Call(`_tiledb_libtiledb_query_set_subarray`, query, subarray)
}

libtiledb_query_set_buffer <- function(query, attr, buffer) {
    .Call(`_tiledb_libtiledb_query_set_buffer`, query, attr, buffer)
}

libtiledb_query_buffer_var_char_alloc_direct <- function(szoffsets, szdata, nullable, cols = 1L) {
    .Call(`_tiledb_libtiledb_query_buffer_var_char_alloc_direct`, szoffsets, szdata, nullable, cols)
}

libtiledb_query_buffer_var_char_create <- function(vec, nullable) {
    .Call(`_tiledb_libtiledb_query_buffer_var_char_create`, vec, nullable)
}

libtiledb_query_set_buffer_var_char <- function(query, attr, bufptr) {
    .Call(`_tiledb_libtiledb_query_set_buffer_var_char`, query, attr, bufptr)
}

libtiledb_query_get_buffer_var_char <- function(bufptr, len = 0L, nchar = 0L) {
    .Call(`_tiledb_libtiledb_query_get_buffer_var_char`, bufptr, len, nchar)
}

libtiledb_query_get_buffer_var_char_simple <- function(bufptr) {
    .Call(`_tiledb_libtiledb_query_get_buffer_var_char_simple`, bufptr)
}

libtiledb_query_buffer_var_vec_create <- function(intoffsets, data) {
    .Call(`_tiledb_libtiledb_query_buffer_var_vec_create`, intoffsets, data)
}

libtiledb_query_set_buffer_var_vec <- function(query, attr, buf) {
    .Call(`_tiledb_libtiledb_query_set_buffer_var_vec`, query, attr, buf)
}

libtiledb_query_get_buffer_var_vec <- function(query, attr, buf) {
    .Call(`_tiledb_libtiledb_query_get_buffer_var_vec`, query, attr, buf)
}

libtiledb_query_buffer_alloc_ptr <- function(domaintype, ncells, nullable = FALSE, numvar = 1L) {
    .Call(`_tiledb_libtiledb_query_buffer_alloc_ptr`, domaintype, ncells, nullable, numvar)
}

libtiledb_query_buffer_assign_ptr <- function(buf, dtype, vec, asint64 = FALSE) {
    .Call(`_tiledb_libtiledb_query_buffer_assign_ptr`, buf, dtype, vec, asint64)
}

libtiledb_query_set_buffer_ptr <- function(query, attr, buf) {
    .Call(`_tiledb_libtiledb_query_set_buffer_ptr`, query, attr, buf)
}

length_from_vlcbuf <- function(buf) {
    .Call(`_tiledb_length_from_vlcbuf`, buf)
}

libtiledb_query_get_buffer_ptr <- function(buf, asint64 = FALSE) {
    .Call(`_tiledb_libtiledb_query_get_buffer_ptr`, buf, asint64)
}

libtiledb_query_submit <- function(query) {
    .Call(`_tiledb_libtiledb_query_submit`, query)
}

libtiledb_query_submit_async <- function(query) {
    .Call(`_tiledb_libtiledb_query_submit_async`, query)
}

libtiledb_query_finalize <- function(query) {
    .Call(`_tiledb_libtiledb_query_finalize`, query)
}

libtiledb_query_status <- function(query) {
    .Call(`_tiledb_libtiledb_query_status`, query)
}

libtiledb_query_result_buffer_elements <- function(query, attribute, which = 1L) {
    .Call(`_tiledb_libtiledb_query_result_buffer_elements`, query, attribute, which)
}

libtiledb_query_result_buffer_elements_vec <- function(query, attribute, nullable = FALSE) {
    .Call(`_tiledb_libtiledb_query_result_buffer_elements_vec`, query, attribute, nullable)
}

libtiledb_query_get_fragment_num <- function(query) {
    .Call(`_tiledb_libtiledb_query_get_fragment_num`, query)
}

libtiledb_query_get_fragment_uri <- function(query, idx) {
    .Call(`_tiledb_libtiledb_query_get_fragment_uri`, query, idx)
}

libtiledb_query_get_fragment_timestamp_range <- function(query, idx) {
    .Call(`_tiledb_libtiledb_query_get_fragment_timestamp_range`, query, idx)
}

libtiledb_subarray <- function(query) {
    .Call(`_tiledb_libtiledb_subarray`, query)
}

libtiledb_subarray_add_range <- function(subarr, iidx, starts, ends, strides = NULL) {
    .Call(`_tiledb_libtiledb_subarray_add_range`, subarr, iidx, starts, ends, strides)
}

libtiledb_subarray_add_range_with_type <- function(subarr, iidx, typestr, starts, ends, strides = NULL) {
    .Call(`_tiledb_libtiledb_subarray_add_range_with_type`, subarr, iidx, typestr, starts, ends, strides)
}

libtiledb_query_set_subarray_object <- function(query, subarr) {
    .Call(`_tiledb_libtiledb_query_set_subarray_object`, query, subarr)
}

libtiledb_query_get_est_result_size <- function(query, attr) {
    .Call(`_tiledb_libtiledb_query_get_est_result_size`, query, attr)
}

libtiledb_query_get_est_result_size_nullable <- function(query, attr) {
    .Call(`_tiledb_libtiledb_query_get_est_result_size_nullable`, query, attr)
}

libtiledb_query_get_est_result_size_var <- function(query, attr) {
    .Call(`_tiledb_libtiledb_query_get_est_result_size_var`, query, attr)
}

libtiledb_query_get_est_result_size_var_nullable <- function(query, attr) {
    .Call(`_tiledb_libtiledb_query_get_est_result_size_var_nullable`, query, attr)
}

libtiledb_query_get_range_num <- function(query, dim_idx) {
    .Call(`_tiledb_libtiledb_query_get_range_num`, query, dim_idx)
}

libtiledb_query_get_range <- function(query, dim_idx, rng_idx) {
    .Call(`_tiledb_libtiledb_query_get_range`, query, dim_idx, rng_idx)
}

libtiledb_query_get_range_var <- function(query, dim_idx, rng_idx) {
    .Call(`_tiledb_libtiledb_query_get_range_var`, query, dim_idx, rng_idx)
}

libtiledb_query_set_condition <- function(query, query_cond) {
    .Call(`_tiledb_libtiledb_query_set_condition`, query, query_cond)
}

libtiledb_query_get_array <- function(query, ctx) {
    .Call(`_tiledb_libtiledb_query_get_array`, query, ctx)
}

libtiledb_query_get_schema <- function(query, ctx) {
    .Call(`_tiledb_libtiledb_query_get_schema`, query, ctx)
}

libtiledb_query_stats <- function(query) {
    .Call(`_tiledb_libtiledb_query_stats`, query)
}

libtiledb_query_get_ctx <- function(query) {
    .Call(`_tiledb_libtiledb_query_get_ctx`, query)
}

libtiledb_query_condition <- function(ctx) {
    .Call(`_tiledb_libtiledb_query_condition`, ctx)
}

libtiledb_query_condition_init <- function(query_cond, attr_name, condition_value, cond_val_type, cond_op_string) {
    invisible(.Call(`_tiledb_libtiledb_query_condition_init`, query_cond, attr_name, condition_value, cond_val_type, cond_op_string))
}

libtiledb_query_condition_combine <- function(lhs, rhs, str) {
    .Call(`_tiledb_libtiledb_query_condition_combine`, lhs, rhs, str)
}

libtiledb_zip_coords_numeric <- function(coords, coord_length) {
    .Call(`_tiledb_libtiledb_zip_coords_numeric`, coords, coord_length)
}

libtiledb_zip_coords_integer <- function(coords, coord_length) {
    .Call(`_tiledb_libtiledb_zip_coords_integer`, coords, coord_length)
}

libtiledb_create_group <- function(ctx, uri) {
    .Call(`_tiledb_libtiledb_create_group`, ctx, uri)
}

libtiledb_object_type <- function(ctx, uri) {
    .Call(`_tiledb_libtiledb_object_type`, ctx, uri)
}

libtiledb_object_remove <- function(ctx, uri) {
    .Call(`_tiledb_libtiledb_object_remove`, ctx, uri)
}

libtiledb_object_move <- function(ctx, old_uri, new_uri) {
    .Call(`_tiledb_libtiledb_object_move`, ctx, old_uri, new_uri)
}

libtiledb_object_walk <- function(ctx, uri, order, recursive = FALSE) {
    .Call(`_tiledb_libtiledb_object_walk`, ctx, uri, order, recursive)
}

libtiledb_vfs <- function(ctx, config = NULL) {
    .Call(`_tiledb_libtiledb_vfs`, ctx, config)
}

libtiledb_vfs_create_bucket <- function(vfs, uri) {
    .Call(`_tiledb_libtiledb_vfs_create_bucket`, vfs, uri)
}

libtiledb_vfs_remove_bucket <- function(vfs, uri) {
    .Call(`_tiledb_libtiledb_vfs_remove_bucket`, vfs, uri)
}

libtiledb_vfs_is_bucket <- function(vfs, uri) {
    .Call(`_tiledb_libtiledb_vfs_is_bucket`, vfs, uri)
}

libtiledb_vfs_is_empty_bucket <- function(vfs, uri) {
    .Call(`_tiledb_libtiledb_vfs_is_empty_bucket`, vfs, uri)
}

libtiledb_vfs_empty_bucket <- function(vfs, uri) {
    .Call(`_tiledb_libtiledb_vfs_empty_bucket`, vfs, uri)
}

libtiledb_vfs_create_dir <- function(vfs, uri) {
    .Call(`_tiledb_libtiledb_vfs_create_dir`, vfs, uri)
}

libtiledb_vfs_is_dir <- function(vfs, uri) {
    .Call(`_tiledb_libtiledb_vfs_is_dir`, vfs, uri)
}

libtiledb_vfs_remove_dir <- function(vfs, uri) {
    .Call(`_tiledb_libtiledb_vfs_remove_dir`, vfs, uri)
}

libtiledb_vfs_is_file <- function(vfs, uri) {
    .Call(`_tiledb_libtiledb_vfs_is_file`, vfs, uri)
}

libtiledb_vfs_remove_file <- function(vfs, uri) {
    .Call(`_tiledb_libtiledb_vfs_remove_file`, vfs, uri)
}

libtiledb_vfs_file_size <- function(vfs, uri) {
    .Call(`_tiledb_libtiledb_vfs_file_size`, vfs, uri)
}

libtiledb_vfs_move_file <- function(vfs, old_uri, new_uri) {
    .Call(`_tiledb_libtiledb_vfs_move_file`, vfs, old_uri, new_uri)
}

libtiledb_vfs_move_dir <- function(vfs, old_uri, new_uri) {
    .Call(`_tiledb_libtiledb_vfs_move_dir`, vfs, old_uri, new_uri)
}

libtiledb_vfs_touch <- function(vfs, uri) {
    .Call(`_tiledb_libtiledb_vfs_touch`, vfs, uri)
}

libtiledb_vfs_open <- function(ctxxp, vfsxp, uri, mode) {
    .Call(`_tiledb_libtiledb_vfs_open`, ctxxp, vfsxp, uri, mode)
}

libtiledb_vfs_close <- function(ctxxp, fh) {
    invisible(.Call(`_tiledb_libtiledb_vfs_close`, ctxxp, fh))
}

libtiledb_vfs_write <- function(ctxxp, fh, vec) {
    invisible(.Call(`_tiledb_libtiledb_vfs_write`, ctxxp, fh, vec))
}

libtiledb_vfs_read <- function(ctxxp, fh, offset, nbytes) {
    .Call(`_tiledb_libtiledb_vfs_read`, ctxxp, fh, offset, nbytes)
}

libtiledb_vfs_sync <- function(ctxxp, fh) {
    invisible(.Call(`_tiledb_libtiledb_vfs_sync`, ctxxp, fh))
}

libtiledb_vfs_dir_size <- function(vfs, uri) {
    .Call(`_tiledb_libtiledb_vfs_dir_size`, vfs, uri)
}

libtiledb_vfs_ls <- function(vfs, uri) {
    .Call(`_tiledb_libtiledb_vfs_ls`, vfs, uri)
}

libtiledb_stats_enable <- function() {
    invisible(.Call(`_tiledb_libtiledb_stats_enable`))
}

libtiledb_stats_disable <- function() {
    invisible(.Call(`_tiledb_libtiledb_stats_disable`))
}

libtiledb_stats_reset <- function() {
    invisible(.Call(`_tiledb_libtiledb_stats_reset`))
}

libtiledb_stats_dump <- function(path = "") {
    invisible(.Call(`_tiledb_libtiledb_stats_dump`, path))
}

libtiledb_stats_raw_dump <- function(path = "") {
    invisible(.Call(`_tiledb_libtiledb_stats_raw_dump`, path))
}

libtiledb_stats_raw_get <- function() {
    .Call(`_tiledb_libtiledb_stats_raw_get`)
}

libtiledb_fragment_info <- function(ctx, uri) {
    .Call(`_tiledb_libtiledb_fragment_info`, ctx, uri)
}

libtiledb_fragment_info_uri <- function(fi, fid) {
    .Call(`_tiledb_libtiledb_fragment_info_uri`, fi, fid)
}

libtiledb_fragment_info_get_non_empty_domain_index <- function(fi, fid, did, typestr) {
    .Call(`_tiledb_libtiledb_fragment_info_get_non_empty_domain_index`, fi, fid, did, typestr)
}

libtiledb_fragment_info_get_non_empty_domain_name <- function(fi, fid, dim_name, typestr) {
    .Call(`_tiledb_libtiledb_fragment_info_get_non_empty_domain_name`, fi, fid, dim_name, typestr)
}

libtiledb_fragment_info_get_non_empty_domain_var_index <- function(fi, fid, did) {
    .Call(`_tiledb_libtiledb_fragment_info_get_non_empty_domain_var_index`, fi, fid, did)
}

libtiledb_fragment_info_get_non_empty_domain_var_name <- function(fi, fid, dim_name) {
    .Call(`_tiledb_libtiledb_fragment_info_get_non_empty_domain_var_name`, fi, fid, dim_name)
}

libtiledb_fragment_info_num <- function(fi) {
    .Call(`_tiledb_libtiledb_fragment_info_num`, fi)
}

libtiledb_fragment_info_size <- function(fi, fid) {
    .Call(`_tiledb_libtiledb_fragment_info_size`, fi, fid)
}

libtiledb_fragment_info_dense <- function(fi, fid) {
    .Call(`_tiledb_libtiledb_fragment_info_dense`, fi, fid)
}

libtiledb_fragment_info_sparse <- function(fi, fid) {
    .Call(`_tiledb_libtiledb_fragment_info_sparse`, fi, fid)
}

libtiledb_fragment_info_timestamp_range <- function(fi, fid) {
    .Call(`_tiledb_libtiledb_fragment_info_timestamp_range`, fi, fid)
}

libtiledb_fragment_info_cell_num <- function(fi, fid) {
    .Call(`_tiledb_libtiledb_fragment_info_cell_num`, fi, fid)
}

libtiledb_fragment_info_version <- function(fi, fid) {
    .Call(`_tiledb_libtiledb_fragment_info_version`, fi, fid)
}

libtiledb_fragment_info_has_consolidated_metadata <- function(fi, fid) {
    .Call(`_tiledb_libtiledb_fragment_info_has_consolidated_metadata`, fi, fid)
}

libtiledb_fragment_info_unconsolidated_metadata_num <- function(fi) {
    .Call(`_tiledb_libtiledb_fragment_info_unconsolidated_metadata_num`, fi)
}

libtiledb_fragment_info_to_vacuum_num <- function(fi) {
    .Call(`_tiledb_libtiledb_fragment_info_to_vacuum_num`, fi)
}

libtiledb_fragment_info_to_vacuum_uri <- function(fi, fid) {
    .Call(`_tiledb_libtiledb_fragment_info_to_vacuum_uri`, fi, fid)
}

libtiledb_fragment_info_dump <- function(fi) {
    invisible(.Call(`_tiledb_libtiledb_fragment_info_dump`, fi))
}

libtiledb_error_message <- function(ctx) {
    .Call(`_tiledb_libtiledb_error_message`, ctx)
}

libtiledb_group <- function(ctx, uri, querytypestr) {
    .Call(`_tiledb_libtiledb_group`, ctx, uri, querytypestr)
}

libtiledb_group_open <- function(grp, querytypestr) {
    .Call(`_tiledb_libtiledb_group_open`, grp, querytypestr)
}

libtiledb_group_set_config <- function(grp, cfg) {
    .Call(`_tiledb_libtiledb_group_set_config`, grp, cfg)
}

libtiledb_group_get_config <- function(grp) {
    .Call(`_tiledb_libtiledb_group_get_config`, grp)
}

libtiledb_group_close <- function(grp) {
    .Call(`_tiledb_libtiledb_group_close`, grp)
}

libtiledb_group_create <- function(ctx, uri) {
    .Call(`_tiledb_libtiledb_group_create`, ctx, uri)
}

libtiledb_group_is_open <- function(grp) {
    .Call(`_tiledb_libtiledb_group_is_open`, grp)
}

libtiledb_group_uri <- function(grp) {
    .Call(`_tiledb_libtiledb_group_uri`, grp)
}

libtiledb_group_query_type <- function(grp) {
    .Call(`_tiledb_libtiledb_group_query_type`, grp)
}

libtiledb_group_put_metadata <- function(grp, key, obj) {
    .Call(`_tiledb_libtiledb_group_put_metadata`, grp, key, obj)
}

libtiledb_group_delete_metadata <- function(grp, key) {
    .Call(`_tiledb_libtiledb_group_delete_metadata`, grp, key)
}

libtiledb_group_get_metadata <- function(grp, key) {
    .Call(`_tiledb_libtiledb_group_get_metadata`, grp, key)
}

libtiledb_group_has_metadata <- function(grp, key) {
    .Call(`_tiledb_libtiledb_group_has_metadata`, grp, key)
}

libtiledb_group_metadata_num <- function(grp) {
    .Call(`_tiledb_libtiledb_group_metadata_num`, grp)
}

libtiledb_group_get_metadata_from_index <- function(grp, idx) {
    .Call(`_tiledb_libtiledb_group_get_metadata_from_index`, grp, idx)
}

libtiledb_group_add_member <- function(grp, uri, relative, optional_name = NULL) {
    .Call(`_tiledb_libtiledb_group_add_member`, grp, uri, relative, optional_name)
}

libtiledb_group_remove_member <- function(grp, uri) {
    .Call(`_tiledb_libtiledb_group_remove_member`, grp, uri)
}

libtiledb_group_member_count <- function(grp) {
    .Call(`_tiledb_libtiledb_group_member_count`, grp)
}

libtiledb_group_member <- function(grp, idx) {
    .Call(`_tiledb_libtiledb_group_member`, grp, idx)
}

libtiledb_group_dump <- function(grp, recursive) {
    .Call(`_tiledb_libtiledb_group_dump`, grp, recursive)
}

libtiledb_group_is_relative <- function(grp, name) {
    .Call(`_tiledb_libtiledb_group_is_relative`, grp, name)
}

libtiledb_filestore_schema_create <- function(ctx, uri) {
    .Call(`_tiledb_libtiledb_filestore_schema_create`, ctx, uri)
}

libtiledb_filestore_uri_import <- function(ctx, filestore_uri, file_uri) {
    .Call(`_tiledb_libtiledb_filestore_uri_import`, ctx, filestore_uri, file_uri)
}

libtiledb_filestore_uri_export <- function(ctx, file_uri, filestore_uri) {
    .Call(`_tiledb_libtiledb_filestore_uri_export`, ctx, file_uri, filestore_uri)
}

libtiledb_filestore_buffer_import <- function(ctx, filestore_uri, buf, size) {
    .Call(`_tiledb_libtiledb_filestore_buffer_import`, ctx, filestore_uri, buf, size)
}

libtiledb_filestore_buffer_export <- function(ctx, filestore_uri, offset, size) {
    .Call(`_tiledb_libtiledb_filestore_buffer_export`, ctx, filestore_uri, offset, size)
}

libtiledb_filestore_size <- function(ctx, filestore_uri) {
    .Call(`_tiledb_libtiledb_filestore_size`, ctx, filestore_uri)
}

libtiledb_mime_type_to_str <- function(mime_type) {
    .Call(`_tiledb_libtiledb_mime_type_to_str`, mime_type)
}

libtiledb_mime_type_from_str <- function(mime_type) {
    .Call(`_tiledb_libtiledb_mime_type_from_str`, mime_type)
}

vecbuf_to_shmem <- function(dir, name, buf, sz, numvar) {
    invisible(.Call(`_tiledb_vecbuf_to_shmem`, dir, name, buf, sz, numvar))
}

vlcbuf_to_shmem <- function(dir, name, buf, vec) {
    invisible(.Call(`_tiledb_vlcbuf_to_shmem`, dir, name, buf, vec))
}

querybuf_from_shmem <- function(path, dtype) {
    .Call(`_tiledb_querybuf_from_shmem`, path, dtype)
}

vlcbuf_from_shmem <- function(datapath, dtype) {
    .Call(`_tiledb_vlcbuf_from_shmem`, datapath, dtype)
}

